=== modified file 'lib/Entity/Application.php'
--- lib/Entity/Application.php	2016-05-10 11:15:48 +0000
+++ lib/Entity/Application.php	2017-01-12 16:50:38 +0000
@@ -46,6 +46,14 @@
      * @var string
      */
     public $name;
+    
+    /**
+     * @SWG\Property(
+     *  description="Application Owner"
+     * )
+     * @var string
+     */
+    public $owner;
 
     /**
      * @SWG\Property(

=== modified file 'lib/Entity/DisplayProfile.php'
--- lib/Entity/DisplayProfile.php	2017-01-25 13:44:32 +0000
+++ lib/Entity/DisplayProfile.php	2017-02-14 08:43:20 +0000
@@ -760,7 +760,7 @@
                         'title' => __('Download Window Start Time'),
                         'type' => 'string',
                         'fieldType' => 'timePicker',
-                        'default' => 0,
+                        'default' => '00:00',
                         'helpText' => __('The start of the time window to connect to the CMS and download updates.'),
                         'enabled' => true,
                         'groupClass' => NULL
@@ -771,7 +771,7 @@
                         'title' => __('Download Window End Time'),
                         'type' => 'string',
                         'fieldType' => 'timePicker',
-                        'default' => 0,
+                        'default' => '00:00',
                         'helpText' => __('The end of the time window to connect to the CMS and download updates.'),
                         'enabled' => true,
                         'groupClass' => NULL
@@ -997,7 +997,7 @@
                         'title' => __('Update Window Start Time'),
                         'type' => 'string',
                         'fieldType' => 'timePicker',
-                        'default' => 0,
+                        'default' => '00:00',
                         'helpText' => __('The start of the time window to install application updates.'),
                         'enabled' => true,
                         'groupClass' => NULL
@@ -1008,7 +1008,7 @@
                         'title' => __('Update Window End Time'),
                         'type' => 'string',
                         'fieldType' => 'timePicker',
-                        'default' => 0,
+                        'default' => '00:00',
                         'helpText' => __('The end of the time window to install application updates.'),
                         'enabled' => true,
                         'groupClass' => NULL

=== modified file 'lib/Factory/ApplicationFactory.php'
--- lib/Factory/ApplicationFactory.php	2016-05-09 13:36:12 +0000
+++ lib/Factory/ApplicationFactory.php	2017-01-12 16:50:38 +0000
@@ -129,6 +129,7 @@
             SELECT `oauth_clients`.id AS `key`,
                 `oauth_clients`.secret,
                 `oauth_clients`.name,
+                `user`.UserName AS owner,
                 `oauth_clients`.authCode,
                 `oauth_clients`.clientCredentials,
                 `oauth_clients`.userId ';
@@ -136,6 +137,8 @@
         $body = '
               FROM `oauth_clients`
         ';
+        
+        $body .= " INNER JOIN `user` ON `user`.userId = `oauth_clients`.userId ";
 
         if ($this->getSanitizer()->getInt('userId', $filterBy) !== null) {
 

=== modified file 'lib/Helper/DataSetUploadHandler.php'
--- lib/Helper/DataSetUploadHandler.php	2016-03-09 10:07:29 +0000
+++ lib/Helper/DataSetUploadHandler.php	2017-01-16 15:58:46 +0000
@@ -48,8 +48,11 @@
                 /* @var \Xibo\Entity\DataSetColumn $column */
                 if ($column->dataSetColumnTypeId == 1) {
                     // Has this column been provided in the mappings?
-                    $spreadSheetColumn = isset($_REQUEST['csvImport_' . $column->dataSetColumnId]) ? $_REQUEST['csvImport_' . $column->dataSetColumnId][$index] : 0;
 
+                    $spreadSheetColumn = 0;
+                    if( isset($_REQUEST['csvImport_' . $column->dataSetColumnId]) )
+                            $spreadSheetColumn = (($index === null) ? $_REQUEST['csvImport_' . $column->dataSetColumnId] : $_REQUEST['csvImport_' . $column->dataSetColumnId][$index]);
+                            
                     // If it has been left blank, then skip
                     if ($spreadSheetColumn != 0)
                         $spreadSheetMapping[($spreadSheetColumn - 1)] = $column->heading;

=== modified file 'lib/Widget/Currencies.php'
--- lib/Widget/Currencies.php	2016-11-16 11:49:12 +0000
+++ lib/Widget/Currencies.php	2017-01-23 15:46:25 +0000
@@ -73,36 +73,11 @@
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/vendor/jquery-1.11.1.min.js')->save();
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/xibo-finance-render.js')->save();
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/xibo-layout-scaler.js')->save();
+        $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/xibo-image-render.js')->save();
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/vendor/bootstrap.min.css')->save();
     }
 
     /**
-     * Loads templates for this module
-     */
-    private function loadTemplates()
-    {
-        $this->module->settings['templates'] = [];
-
-        // Scan the folder for template files
-        foreach (glob(PROJECT_ROOT . '/modules/currencies/*.template.json') as $template) {
-            // Read the contents, json_decode and add to the array
-            $this->module->settings['templates'][] = json_decode(file_get_contents($template), true);
-        }
-    }
-
-    /**
-     * Templates available
-     * @return array
-     */
-    public function templatesAvailable()
-    {
-        if (!isset($this->module->settings['templates']))
-            $this->loadTemplates();
-
-        return $this->module->settings['templates'];
-    }
-
-    /**
      * Form for updating the module settings
      */
     public function settingsForm()
@@ -123,6 +98,9 @@
 
     public function validate()
     {
+        if($this->getOption('overrideTemplate') == 0 && ( $this->getOption('templateId') == '' || $this->getOption('templateId') == null) )
+            throw new \InvalidArgumentException(__('Please choose a template'));
+            
         if ($this->getUseDuration() == 1 && $this->getDuration() == 0)
             throw new \InvalidArgumentException(__('Please enter a duration'));
     }
@@ -163,17 +141,21 @@
         $this->setOption('backgroundColor', $this->getSanitizer()->getString('backgroundColor'));
         $this->setOption('noRecordsMessage', $this->getSanitizer()->getString('noRecordsMessage'));
         $this->setOption('dateFormat', $this->getSanitizer()->getString('dateFormat'));
-        $this->setOption('overrideTemplate', $this->getSanitizer()->getCheckbox('overrideTemplate'));
+        $this->setOption('reverseConversion', $this->getSanitizer()->getCheckbox('reverseConversion'));
         $this->setOption('updateInterval', $this->getSanitizer()->getInt('updateInterval', 60));
         $this->setOption('templateId', $this->getSanitizer()->getString('templateId'));
         $this->setOption('durationIsPerPage', $this->getSanitizer()->getCheckbox('durationIsPerPage'));
-        $this->setOption('widgetOriginalWidth', $this->getSanitizer()->getInt('widgetOriginalWidth'));
-        $this->setOption('widgetOriginalHeight', $this->getSanitizer()->getInt('widgetOriginalHeight'));
-        $this->setOption('maxItemsPerPage', $this->getSanitizer()->getInt('maxItemsPerPage', 4));
-        $this->setRawNode('mainTemplate', $this->getSanitizer()->getParam('mainTemplate', $this->getSanitizer()->getParam('mainTemplate', null)));
-        $this->setRawNode('itemTemplate', $this->getSanitizer()->getParam('itemTemplate', $this->getSanitizer()->getParam('itemTemplate', null)));
-        $this->setRawNode('styleSheet', $this->getSanitizer()->getParam('styleSheet', $this->getSanitizer()->getParam('styleSheet', null)));
         $this->setRawNode('javaScript', $this->getSanitizer()->getParam('javaScript', ''));
+        $this->setOption('overrideTemplate', $this->getSanitizer()->getCheckbox('overrideTemplate'));
+        
+        if( $this->getOption('overrideTemplate') == 1 ){
+            $this->setRawNode('mainTemplate', $this->getSanitizer()->getParam('mainTemplate', $this->getSanitizer()->getParam('mainTemplate', null)));
+            $this->setRawNode('itemTemplate', $this->getSanitizer()->getParam('itemTemplate', $this->getSanitizer()->getParam('itemTemplate', null)));
+            $this->setRawNode('styleSheet', $this->getSanitizer()->getParam('styleSheet', $this->getSanitizer()->getParam('styleSheet', null)));
+            $this->setOption('widgetOriginalWidth', $this->getSanitizer()->getInt('widgetOriginalWidth'));
+            $this->setOption('widgetOriginalHeight', $this->getSanitizer()->getInt('widgetOriginalHeight'));
+            $this->setOption('maxItemsPerPage', $this->getSanitizer()->getInt('maxItemsPerPage', 4));
+        }
     }
 
     /**
@@ -182,6 +164,9 @@
      */
     protected function getYql()
     {
+        
+        $reverseConversion = ($this->getOption('reverseConversion', 0) == 1);
+
         $items = $this->getOption('items');
         $base = $this->getOption('base');
         
@@ -209,10 +194,17 @@
             
         // quote each item
         $itemsJoined = array();
+        
         foreach ($items as $key => $item) {
+            
+            // Remove the multiplier if there's one
+            $item = explode('|', $item)[0];
+            
+            $baseItemPair = ( $reverseConversion ) ? ( trim($item) . trim($base) ) : ( trim($base) . trim($item) );
+            
             array_push(
                 $itemsJoined, 
-                ( $useVariation ) ? ('\'' . trim($base) . trim($item) . '=X' . '\'') : ('\'' . trim($base) . trim($item) . '\'')
+                ( $useVariation ) ? ('\'' . $baseItemPair . '=X' . '\'') : ('\'' . $baseItemPair . '\'')
             );
         }
 
@@ -260,6 +252,16 @@
         // Replace all matches.
         $matches = '';
         preg_match_all('/\[.*?\]/', $source, $matches);
+        
+        // Get the currencies' items
+        $items = $this->getOption('items');
+        
+        if (strstr($items, ','))
+            $items = explode(',', $items);
+        else
+            $items = [$items];
+        
+        $reverseConversion = ($this->getOption('reverseConversion', 0) == 1);
 
         // Substitute
         foreach ($matches[0] as $sub) {
@@ -299,14 +301,44 @@
                     // Replace the other tags
                     switch ($replace) {
                         case 'NameShort':
-                            // Replace the name to have just the second currency
-                            if (isset($data['Name']))
-                                $replacement = str_replace(($baseCurrency . '/'),'',$data['Name']);
-                                
+                            // Replace the name to have just the second currency (or the first if the currency is reversed)
+                            $replaceBase = ( $reverseConversion ) ? ('/' . $baseCurrency) : ($baseCurrency . '/');
+                            
+                            if (isset($data['Name']))
+                                $replacement = trim(str_replace($replaceBase,'',$data['Name']));
+                                    
+                            break;
+                            
+                        case 'Multiplier':
+                            
+                            // Initialize replacement with empty string 
+                            $replacement = '';
+                            
+                            // Get the current currency name/code
+                            $pairName = ( $reverseConversion ) ? ('/' . $baseCurrency) : ($baseCurrency . '/');
+                            
+                            if (isset($data['Name']))
+                                $currencyName = trim(str_replace($pairName,'',$data['Name']));
+                            
+                            // Search for the item that relates to the actual currency
+                            foreach ($items as $item) {
+                                
+                                // Get the item name
+                                $itemName = trim(explode('|', $item)[0]);
+                                
+                                // Compare the item name with the actual currency and test if the inputed value has a multiplier flag
+                                if( sizeof(explode('|', $item)) > 1 && strcmp($itemName, $currencyName) == 0 ){
+                                    
+                                    // Get the multiplier
+                                    $replacement = explode('|', $item)[1];
+                                }
+                            }
+                            
                             break;
                             
                         case 'CurrencyFlag':
-                            $currencyCode = str_replace(($baseCurrency . '/'),'',$data['Name']);
+                            $replaceBase = ( $reverseConversion ) ? ('/' . $baseCurrency) : ($baseCurrency . '/');
+                            $currencyCode = str_replace($replaceBase,'',$data['Name']);
                             
                             if (!file_exists(PROJECT_ROOT . '/web/modules/currencies/currency-flags/' . $currencyCode . '.svg')) 
                                 $currencyCode = 'default';
@@ -337,6 +369,38 @@
                             
                             break;
                             
+                        case 'LastTradePriceOnlyValue':
+                        case 'BidValue':
+                        case 'AskValue':
+                            
+                            // Get the converted currency name
+                            $currencyName = ( $reverseConversion ) ? ('/' . $baseCurrency) : ($baseCurrency . '/');
+                            
+                            if (isset($data['Name']))
+                                $currencyName = trim(str_replace($currencyName, '', $data['Name']));
+                            
+                            // Get the field's name and set the replacement as the default value from the API
+                            $fieldName = str_replace('Value', '', $replace);
+                            $replacement = $data[$fieldName];
+                                
+                            // Search for the item that relates to the actual currency
+                            foreach ($items as $item) {
+                                
+                                // Get the item name
+                                $itemName = trim(explode('|', $item)[0]);
+                                
+                                // Compare the item name with the actual currency and test if the inputed value has a multiplier flag
+                                if( sizeof(explode('|', $item)) > 1 && strcmp($itemName, $currencyName) == 0 ){
+                                    // Get the multiplier
+                                    $multiplier = explode('|', $item)[1];
+                                    
+                                    // Set the replacement to be the API value times the multiplier
+                                    $replacement = $data[$fieldName] * (float)$multiplier;
+                                }
+                            }        
+                            
+                            break;
+                            
                         case 'ChangeStyle':
                             // Default value as no change
                             $replacement = 'value-equal';
@@ -375,12 +439,6 @@
                             $replacement = strtoupper($data['Currency']);
                             
                             break;
-                            
-                        case 'CurrencyUpper':
-                            // Currency in uppercase
-                            $replacement = strtoupper($data['Currency']);
-                            
-                            break;
                                 
                         default:
                             $replacement = 'NULL';
@@ -430,9 +488,32 @@
             return '';
         }
 
+        if( $this->getOption('overrideTemplate') == 0 ) {
+            
+            $template = $this->getTemplateById($this->getOption('templateId'));
+            
+            if (isset($template)) {
+                $mainTemplate = $template['main'];
+                $itemTemplate = $template['item'];
+                $styleSheet = $template['css'];
+                $widgetOriginalWidth = $template['widgetOriginalWidth'];
+                $widgetOriginalHeight = $template['widgetOriginalHeight'];
+                $maxItemsPerPage = $template['maxItemsPerPage'];
+            }
+            
+        } else {
+            
+            $mainTemplate = $this->getRawNode('mainTemplate');
+            $itemTemplate = $this->getRawNode('itemTemplate');
+            $styleSheet = $this->getRawNode('styleSheet', '');
+            $widgetOriginalWidth = $this->getSanitizer()->int($this->getOption('widgetOriginalWidth'));
+            $widgetOriginalHeight = $this->getSanitizer()->int($this->getOption('widgetOriginalHeight'));
+            $maxItemsPerPage = $this->getSanitizer()->int($this->getOption('maxItemsPerPage'));
+        }
+        
         // Run through each item and substitute with the template
-        $mainTemplate = $this->parseLibraryReferences($isPreview, $this->getRawNode('mainTemplate'));
-        $itemTemplate = $this->parseLibraryReferences($isPreview, $this->getRawNode('itemTemplate'));
+        $mainTemplate = $this->parseLibraryReferences($isPreview, $mainTemplate);
+        $itemTemplate = $this->parseLibraryReferences($isPreview, $itemTemplate);
         
         $renderedItems = [];
         
@@ -453,10 +534,10 @@
             'originalHeight' => $this->region->height,
             'previewWidth' => $this->getSanitizer()->getDouble('width', 0),
             'previewHeight' => $this->getSanitizer()->getDouble('height', 0),
-            'widgetDesignWidth' => $this->getSanitizer()->int($this->getOption('widgetOriginalWidth')),
-            'widgetDesignHeight'=> $this->getSanitizer()->int($this->getOption('widgetOriginalHeight')),
+            'widgetDesignWidth' => $widgetOriginalWidth,
+            'widgetDesignHeight'=> $widgetOriginalHeight,
             'scaleOverride' => $this->getSanitizer()->getDouble('scale_override', 0), 
-            'maxItemsPerPage' => $this->getSanitizer()->int($this->getOption('maxItemsPerPage'))
+            'maxItemsPerPage' => $maxItemsPerPage
         );
 
         $itemsPerPage = $options['maxItemsPerPage'];
@@ -483,7 +564,7 @@
         }
         
         // Add the CSS if it isn't empty, and replace the wallpaper
-        $css = $this->makeSubstitutions([], $this->getRawNode('styleSheet', null), '');
+        $css = $this->makeSubstitutions([], $styleSheet, '');
 
         if ($css != '') {
             $headContent .= '<style type="text/css">' . $this->parseLibraryReferences($isPreview, $css) . '</style>';
@@ -500,13 +581,14 @@
 
         $javaScriptContent .= '<script type="text/javascript" src="' . $this->getResourceUrl('xibo-layout-scaler.js') . '"></script>';
         $javaScriptContent .= '<script type="text/javascript" src="' . $this->getResourceUrl('xibo-finance-render.js') . '"></script>';
+        $javaScriptContent .= '<script type="text/javascript" src="' . $this->getResourceUrl('xibo-image-render.js') . '"></script>';
 
         $javaScriptContent .= '<script type="text/javascript">';
         $javaScriptContent .= '   var options = ' . json_encode($options) . ';';
         $javaScriptContent .= '   var items = ' . json_encode($renderedItems) . ';';
         $javaScriptContent .= '   var body = ' . json_encode($mainTemplate) . ';';
         $javaScriptContent .= '   $(document).ready(function() { ';
-        $javaScriptContent .= '       $("body").xiboLayoutScaler(options); $("#content").xiboFinanceRender(options, items, body); ';
+        $javaScriptContent .= '       $("body").xiboLayoutScaler(options); $("#content").xiboFinanceRender(options, items, body); $("#content").find("img").xiboImageRender(options); ';
         $javaScriptContent .= '   }); ';
         $javaScriptContent .= $javaScript;
         $javaScriptContent .= '</script>';

=== modified file 'lib/Widget/DataSetView.php'
--- lib/Widget/DataSetView.php	2016-12-15 12:33:44 +0000
+++ lib/Widget/DataSetView.php	2017-01-23 15:46:25 +0000
@@ -40,6 +40,7 @@
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/vendor/jquery-cycle-2.1.6.min.js')->save();
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/xibo-layout-scaler.js')->save();
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/xibo-dataset-render.js')->save();
+        $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/xibo-image-render.js')->save();
     }
 
     /**
@@ -119,22 +120,6 @@
     }
 
     /**
-     * Loads templates for this module
-     */
-    private function loadTemplates()
-    {
-        $this->module->settings['templates'] = [];
-
-        // Scan the folder for template files
-        foreach (glob(PROJECT_ROOT . '/modules/datasetview/*.template.json') as $template) {
-            // Read the contents, json_decode and add to the array
-            $this->module->settings['templates'][] = json_decode(file_get_contents($template), true);
-        }
-
-        $this->getLog()->debug(count($this->module->settings['templates']));
-    }
-
-    /**
      * Get the Order Clause
      * @return mixed
      */
@@ -168,18 +153,6 @@
     }
 
     /**
-     * Templates available
-     * @return array
-     */
-    public function templatesAvailable()
-    {
-        if (!isset($this->module->settings['templates']))
-            $this->loadTemplates();
-
-        return $this->module->settings['templates'];
-    }
-
-    /**
      * validate
      */
     public function validate()
@@ -262,6 +235,10 @@
         $this->setOption('useFilteringClause', $this->getSanitizer()->getCheckbox('useFilteringClause'));
         $this->setRawNode('noDataMessage', $this->getSanitizer()->getParam('noDataMessage', ''));
         $this->setRawNode('javaScript', $this->getSanitizer()->getParam('javaScript', ''));
+        
+        if( $this->getOption('overrideTemplate') == 1 ){
+            $this->setRawNode('styleSheet', $this->getSanitizer()->getParam('styleSheet', null));
+        }
 
         // Order and Filter criteria
         $orderClauses = $this->getSanitizer()->getStringArray('orderClause');
@@ -308,9 +285,6 @@
 
         $this->setOption('filterClauses', json_encode($filterClauseMapping));
 
-        // Style Sheet
-        $this->setRawNode('styleSheet', $this->getSanitizer()->getParam('styleSheet', null));
-
         // Save the widget
         $this->validate();
         $this->saveWidget();
@@ -361,9 +335,21 @@
 
         // Replace the View Port Width?
         $data['viewPortWidth'] = ($isPreview) ? $this->region->width : '[[ViewPortWidth]]';
-
+    
+        // Get CSS from the original template or from the input field
+        if( $this->getOption('overrideTemplate') == 0 ) {
+            
+            $template = $this->getTemplateById($this->getOption('templateId'));
+            
+            if (isset($template))
+                $styleSheet = $template['css'];
+                    
+        } else {
+                $styleSheet = $this->getRawNode('styleSheet', '');
+        }
+        
         // Get the embedded HTML out of RAW
-        $styleSheet = $this->parseLibraryReferences($isPreview, $this->getRawNode('styleSheet', ''));
+        $styleSheet = $this->parseLibraryReferences($isPreview, $styleSheet);
 
         // Get the JavaScript node
         $javaScript = $this->parseLibraryReferences($isPreview, $this->getRawNode('javaScript', ''));
@@ -393,11 +379,12 @@
 
         $javaScriptContent .= '<script type="text/javascript" src="' . $this->getResourceUrl('xibo-layout-scaler.js') . '"></script>';
         $javaScriptContent .= '<script type="text/javascript" src="' . $this->getResourceUrl('xibo-dataset-render.js') . '"></script>';
+        $javaScriptContent .= '<script type="text/javascript" src="' . $this->getResourceUrl('xibo-image-render.js') . '"></script>';
 
         $javaScriptContent .= '<script type="text/javascript">';
         $javaScriptContent .= '   var options = ' . json_encode($options) . ';';
         $javaScriptContent .= '   $(document).ready(function() { ';
-        $javaScriptContent .= '       $("#DataSetTableContainer").dataSetRender(options); $("body").xiboLayoutScaler(options);';
+        $javaScriptContent .= '       $("#DataSetTableContainer").dataSetRender(options); $("body").xiboLayoutScaler(options); $("#DataSetTableContainer").find("img").xiboImageRender(options); ';
         $javaScriptContent .= '   }); ';
         $javaScriptContent .= $javaScript;
         $javaScriptContent .= '</script>';

=== modified file 'lib/Widget/Embedded.php'
--- lib/Widget/Embedded.php	2016-12-21 13:00:45 +0000
+++ lib/Widget/Embedded.php	2017-01-11 15:28:44 +0000
@@ -30,6 +30,7 @@
     {
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/vendor/jquery-1.11.1.min.js')->save();
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/xibo-layout-scaler.js')->save();
+        $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/xibo-image-render.js')->save();
     }
 
     /**
@@ -99,6 +100,7 @@
         // Include some vendor items
         $javaScriptContent  = '<script type="text/javascript" src="' . $this->getResourceUrl('vendor/jquery-1.11.1.min.js') . '"></script>';
         $javaScriptContent .= '<script type="text/javascript" src="' . $this->getResourceUrl('xibo-layout-scaler.js') . '"></script>';
+        $javaScriptContent .= '<script type="text/javascript" src="' . $this->getResourceUrl('xibo-image-render.js') . '"></script>';
 
         // Get the Script
         $javaScriptContent .= $this->parseLibraryReferences($isPreview, $this->getRawNode('embedScript', null));
@@ -119,6 +121,7 @@
         $javaScriptContent .= '<script type="text/javascript">';
         $javaScriptContent .= '   var options = ' . json_encode($options) . ';';
         $javaScriptContent .= '   $(document).ready(function() { EmbedInit(); });';
+        $javaScriptContent .= '   $("body").find("img").xiboImageRender(options);';
         $javaScriptContent .= '</script>';
 
         // Do we want to scale?

=== modified file 'lib/Widget/Finance.php'
--- lib/Widget/Finance.php	2016-11-16 11:49:12 +0000
+++ lib/Widget/Finance.php	2017-01-23 15:46:25 +0000
@@ -72,38 +72,11 @@
     {
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/vendor/jquery-1.11.1.min.js')->save();
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/xibo-text-render.js')->save();
+        $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/xibo-image-render.js')->save();
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/xibo-layout-scaler.js')->save();
     }
 
     /**
-     * Loads templates for this module
-     */
-    private function loadTemplates()
-    {
-        $this->module->settings['templates'] = [];
-
-        // Scan the folder for template files
-        foreach (glob(PROJECT_ROOT . '/modules/finance/*.template.json') as $template) {
-            // Read the contents, json_decode and add to the array
-            $this->module->settings['templates'][] = json_decode(file_get_contents($template), true);
-        }
-
-        $this->getLog()->debug(count($this->module->settings['templates']));
-    }
-
-    /**
-     * Templates available
-     * @return array
-     */
-    public function templatesAvailable()
-    {
-        if (!isset($this->module->settings['templates']))
-            $this->loadTemplates();
-
-        return $this->module->settings['templates'];
-    }
-
-    /**
      * Form for updating the module settings
      */
     public function settingsForm()
@@ -123,7 +96,11 @@
     }
 
     public function validate()
-    {
+    {        
+        // If overrideTemplate is false we have to define a template Id 
+        if($this->getOption('overrideTemplate') == 0 && ( $this->getOption('templateId') == '' || $this->getOption('templateId') == null) )
+            throw new \InvalidArgumentException(__('Please choose a template'));
+                
         if ($this->getUseDuration() == 1 && $this->getDuration() == 0)
             throw new \InvalidArgumentException(__('Please enter a duration'));
     }
@@ -157,9 +134,7 @@
         $this->setDuration($this->getSanitizer()->getInt('duration', $this->getDuration()));
         $this->setUseDuration($this->getSanitizer()->getCheckbox('useDuration'));
         $this->setOption('name', $this->getSanitizer()->getString('name'));
-        $this->setOption('yql', $this->getSanitizer()->getString('yql'));
         $this->setOption('item', $this->getSanitizer()->getString('item'));
-        $this->setOption('resultIdentifier', $this->getSanitizer()->getString('resultIdentifier'));
         $this->setOption('effect', $this->getSanitizer()->getString('effect'));
         $this->setOption('speed', $this->getSanitizer()->getInt('speed'));
         $this->setOption('backgroundColor', $this->getSanitizer()->getString('backgroundColor'));
@@ -169,9 +144,15 @@
         $this->setOption('updateInterval', $this->getSanitizer()->getInt('updateInterval', 60));
         $this->setOption('templateId', $this->getSanitizer()->getString('templateId'));
         $this->setOption('durationIsPerItem', $this->getSanitizer()->getCheckbox('durationIsPerItem'));
-        $this->setRawNode('template', $this->getSanitizer()->getParam('ta_text', $this->getSanitizer()->getParam('template', null)));
-        $this->setRawNode('styleSheet', $this->getSanitizer()->getParam('ta_css', $this->getSanitizer()->getParam('styleSheet', null)));
         $this->setRawNode('javaScript', $this->getSanitizer()->getParam('javaScript', ''));
+        
+        if( $this->getOption('overrideTemplate') == 1 ){
+            $this->setRawNode('template', $this->getSanitizer()->getParam('ta_text', $this->getSanitizer()->getParam('template', null)));
+            $this->setRawNode('styleSheet', $this->getSanitizer()->getParam('ta_css', $this->getSanitizer()->getParam('styleSheet', null)));
+            $this->setOption('yql', $this->getSanitizer()->getString('yql'));
+            $this->setOption('resultIdentifier', $this->getSanitizer()->getString('resultIdentifier'));
+        }
+        
     }
 
     /**
@@ -182,7 +163,25 @@
     {
         // Construct the YQL
         // process items
-        $yql = $this->getOption('yql');
+        
+        if( $this->getOption('overrideTemplate') == 0 ) {
+            
+            // Get YQL and result identifier from the default templates
+            
+            $tmplt = $this->getTemplateById($this->getOption('templateId'));
+            
+            if (isset($tmplt)) {
+                $yql = $tmplt['yql'];
+                $resultIdentifier = $tmplt['resultIdentifier'];
+            }
+            
+        } else {
+            // Get YQL and result identifier from the override input fields
+            
+            $yql = $this->getOption('yql');
+            $resultIdentifier = $this->getOption('resultIdentifier');
+        }
+        
         $items = $this->getOption('item');
 
         $this->getLog()->debug('Finance module with YQL = . Looking for %s in response', $yql, $items);
@@ -228,7 +227,7 @@
 
         // Pull out the results according to the resultIdentifier
         // If the element to return is an array and we aren't, then box.
-        $results = $data[$this->getOption('resultIdentifier')];
+        $results = $data[$resultIdentifier];
 
         if (array_key_exists(0, $results))
             return $results;
@@ -305,9 +304,28 @@
         if (!$items = $this->getYql()) {
             return '';
         }
-
-        // Run through each item and substitute with the template
-        $template = $this->parseLibraryReferences($isPreview, $this->getRawNode('template'));
+        
+        if( $this->getOption('overrideTemplate') == 0 ) {
+            
+            // Get CSS and HTML from the default templates
+            
+            $tmplt = $this->getTemplateById($this->getOption('templateId'));
+            
+            if (isset($tmplt)) {
+                $template = $tmplt['template'];
+                $css = $tmplt['css'];
+            }
+            
+        } else {
+            // Get CSS and HTML from the override input fields
+            
+            // Run through each item and substitute with the template
+            $template = $this->parseLibraryReferences($isPreview, $this->getRawNode('template'));    
+            
+            // Get stylesheet
+            $css = $this->getRawNode('styleSheet', null);
+        }
+        
         $renderedItems = [];
 
         foreach ($items as $item) {
@@ -341,7 +359,6 @@
         $headContent = '';
 
         // Add the CSS if it isn't empty
-        $css = $this->getRawNode('styleSheet', null);
         if ($css != '') {
             $headContent .= '<style type="text/css">' . $this->parseLibraryReferences($isPreview, $css ) . '</style>';
         }
@@ -371,12 +388,14 @@
 
         $javaScriptContent .= '<script type="text/javascript" src="' . $this->getResourceUrl('xibo-layout-scaler.js') . '"></script>';
         $javaScriptContent .= '<script type="text/javascript" src="' . $this->getResourceUrl('xibo-text-render.js') . '"></script>';
+        $javaScriptContent .= '<script type="text/javascript" src="' . $this->getResourceUrl('xibo-image-render.js') . '"></script>';
+        
 
         $javaScriptContent .= '<script type="text/javascript">';
         $javaScriptContent .= '   var options = ' . json_encode($options) . ';';
         $javaScriptContent .= '   var items = ' . json_encode($renderedItems) . ';';
         $javaScriptContent .= '   $(document).ready(function() { ';
-        $javaScriptContent .= '       $("body").xiboLayoutScaler(options); $("#content").xiboTextRender(options, items); ';
+        $javaScriptContent .= '       $("body").xiboLayoutScaler(options); $("#content").xiboTextRender(options, items); $("#content").find("img").xiboImageRender(options); ';
         $javaScriptContent .= '   }); ';
         $javaScriptContent .= $javaScript;
         $javaScriptContent .= '</script>';

=== modified file 'lib/Widget/ForecastIo.php'
--- lib/Widget/ForecastIo.php	2017-01-06 10:54:38 +0000
+++ lib/Widget/ForecastIo.php	2017-02-14 08:43:20 +0000
@@ -81,6 +81,7 @@
     {
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/vendor/jquery-1.11.1.min.js')->save();
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/xibo-layout-scaler.js')->save();
+        $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/xibo-image-render.js')->save();
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/vendor/bootstrap.min.css')->save();
 
         foreach ($this->mediaFactory->createModuleFileFromFolder($this->resourceFolder) as $media) {
@@ -112,34 +113,12 @@
         $this->module->settings['cachePeriod'] = $this->getSanitizer()->getInt('cachePeriod', 300);
     }
 
-    /**
-     * Loads templates for this module
-     */
-    private function loadTemplates()
-    {
-        // Scan the folder for template files
-        foreach (glob(PROJECT_ROOT . '/modules/forecastio/*.template.json') as $template) {
-            // Read the contents, json_decode and add to the array
-            $this->module->settings['templates'][] = json_decode(file_get_contents($template), true);
-        }
-
-        $this->getLog()->debug(count($this->module->settings['templates']));
-    }
-
-    /**
-     * Templates available
-     * @return array
-     */
-    public function templatesAvailable()
-    {
-        if (!isset($this->module->settings['templates']))
-            $this->loadTemplates();
-
-        return $this->module->settings['templates'];
-    }
-
     public function validate()
     {
+        
+        if($this->getOption('overrideTemplate') == 0 && ( $this->getOption('templateId') == '' || $this->getOption('templateId') == null) )
+            throw new \InvalidArgumentException(__('Please choose a template'));
+            
         if ($this->getUseDuration() == 1 && $this->getDuration() == 0)
             throw new \InvalidArgumentException(__('Please enter a duration'));
 
@@ -165,20 +144,22 @@
         $this->setOption('longitude', $this->getSanitizer()->getDouble('longitude'));
         $this->setOption('latitude', $this->getSanitizer()->getDouble('latitude'));
         $this->setOption('templateId', $this->getSanitizer()->getString('templateId'));
-        $this->setOption('icons', $this->getSanitizer()->getString('icons'));
         $this->setOption('overrideTemplate', $this->getSanitizer()->getCheckbox('overrideTemplate'));
         $this->setOption('units', $this->getSanitizer()->getString('units'));
         $this->setOption('updateInterval', $this->getSanitizer()->getInt('updateInterval', 60));
         $this->setOption('lang', $this->getSanitizer()->getString('lang'));
         $this->setOption('dayConditionsOnly', $this->getSanitizer()->getCheckbox('dayConditionsOnly'));
         
-        $this->setOption('widgetOriginalWidth', $this->getSanitizer()->getInt('widgetOriginalWidth'));
-        $this->setOption('widgetOriginalHeight', $this->getSanitizer()->getInt('widgetOriginalHeight'));
-        $this->setRawNode('styleSheet', $this->getSanitizer()->getParam('styleSheet', null));
-        $this->setRawNode('currentTemplate', $this->getSanitizer()->getParam('currentTemplate', null));
-        $this->setRawNode('dailyTemplate', $this->getSanitizer()->getParam('dailyTemplate', null));
+        if( $this->getOption('overrideTemplate') == 1 ){
+            $this->setRawNode('styleSheet', $this->getSanitizer()->getParam('styleSheet', null));
+            $this->setRawNode('currentTemplate', $this->getSanitizer()->getParam('currentTemplate', null));
+            $this->setRawNode('dailyTemplate', $this->getSanitizer()->getParam('dailyTemplate', null));
+            $this->setOption('widgetOriginalWidth', $this->getSanitizer()->getInt('widgetOriginalWidth'));
+            $this->setOption('widgetOriginalHeight', $this->getSanitizer()->getInt('widgetOriginalHeight'));
+        }
+        
         $this->setRawNode('javaScript', $this->getSanitizer()->getParam('javaScript', ''));
-
+        
         // Save the widget
         $this->validate();
         $this->saveWidget();
@@ -196,18 +177,20 @@
         $this->setOption('longitude', $this->getSanitizer()->getDouble('longitude'));
         $this->setOption('latitude', $this->getSanitizer()->getDouble('latitude'));
         $this->setOption('templateId', $this->getSanitizer()->getString('templateId'));
-        $this->setOption('icons', $this->getSanitizer()->getString('icons'));
         $this->setOption('overrideTemplate', $this->getSanitizer()->getCheckbox('overrideTemplate'));
         $this->setOption('units', $this->getSanitizer()->getString('units'));
         $this->setOption('updateInterval', $this->getSanitizer()->getInt('updateInterval', 60));
         $this->setOption('lang', $this->getSanitizer()->getString('lang'));
         $this->setOption('dayConditionsOnly', $this->getSanitizer()->getCheckbox('dayConditionsOnly'));
+        
+        if( $this->getOption('overrideTemplate') == 1 ){
+            $this->setRawNode('styleSheet', $this->getSanitizer()->getParam('styleSheet', null));
+            $this->setRawNode('currentTemplate', $this->getSanitizer()->getParam('currentTemplate', null));
+            $this->setRawNode('dailyTemplate', $this->getSanitizer()->getParam('dailyTemplate', null));
+            $this->setOption('widgetOriginalWidth', $this->getSanitizer()->getInt('widgetOriginalWidth'));
+            $this->setOption('widgetOriginalHeight', $this->getSanitizer()->getInt('widgetOriginalHeight'));
+        }
 
-        $this->setOption('widgetOriginalWidth', $this->getSanitizer()->getInt('widgetOriginalWidth'));
-        $this->setOption('widgetOriginalHeight', $this->getSanitizer()->getInt('widgetOriginalHeight'));
-        $this->setRawNode('styleSheet', $this->getSanitizer()->getParam('styleSheet', null));
-        $this->setRawNode('currentTemplate', $this->getSanitizer()->getParam('currentTemplate', null));
-        $this->setRawNode('dailyTemplate', $this->getSanitizer()->getParam('dailyTemplate', null));
         $this->setRawNode('javaScript', $this->getSanitizer()->getParam('javaScript', ''));
 
         // Save the widget
@@ -215,19 +198,6 @@
         $this->saveWidget();
     }
 
-    public function iconsAvailable()
-    {
-        // Scan the forecast io folder for icons
-        $icons = array();
-
-        foreach (array_diff(scandir($this->resourceFolder), array('..', '.')) as $file) {
-            if (stripos($file, '-icons.png'))
-                $icons[] = array('id' => $file, 'value' => ucfirst(str_replace('-', ' ', str_replace('.png', '', $file))));
-        }
-
-        return $icons;
-    }
-
     /**
      * Units supported by Forecast.IO API
      * @return array The Units Available (temperature, wind speed and visible distance)
@@ -552,7 +522,35 @@
 
         // Replace the View Port Width?
         $data['viewPortWidth'] = ($isPreview) ? $this->region->width : '[[ViewPortWidth]]';
+        
+        if( $this->getOption('overrideTemplate') == 0 ) {
+            
+            // Get CSS and HTML from the default templates
 
+            $template = $this->getTemplateById($this->getOption('templateId'));
+            
+            if (isset($template)) {
+                $body = $template['main'];
+                $dailyTemplate = $template['daily'];
+                $styleSheet = $template['css'];
+                $widgetOriginalWidth = $template['widgetOriginalWidth'];
+                $widgetOriginalHeight = $template['widgetOriginalHeight'];
+            }
+            
+        } else {
+            // Get CSS and HTML from the override input fields
+            
+            $body = $this->parseLibraryReferences($isPreview, $this->getRawNode('currentTemplate', ''));
+            $dailyTemplate = $this->parseLibraryReferences($isPreview, $this->getRawNode('dailyTemplate', ''));
+            $styleSheet = $this->getRawNode('styleSheet', '');
+            $widgetOriginalWidth = $this->getSanitizer()->int($this->getOption('widgetOriginalWidth'));
+            $widgetOriginalHeight = $this->getSanitizer()->int($this->getOption('widgetOriginalHeight'));
+        }
+        
+        // Parse library references
+        $body = $this->parseLibraryReferences($isPreview, $body);
+        $dailyTemplate = $this->parseLibraryReferences($isPreview, $dailyTemplate);
+        
         // Provide the background images to the templates styleSheet
         $styleSheet = $this->makeSubstitutions([
             'cloudy-image' => $this->getResourceUrl('forecastio/wi-cloudy.jpg'),
@@ -565,7 +563,7 @@
             'rain-image' => $this->getResourceUrl('forecastio/wi-rain.jpg'),
             'snow-image' => $this->getResourceUrl('forecastio/wi-snow.jpg'),
             'windy' => $this->getResourceUrl('forecastio/wi-windy.jpg'),
-          ], $this->getRawNode('styleSheet', null)
+          ], $styleSheet
         );
 
         $headContent = '
@@ -586,10 +584,6 @@
         // Replace any icon sets
         $data['head'] = str_replace('[[ICONS]]', $this->getResourceUrl('forecastio/' . $this->getOption('icons')), $headContent);
 
-        // Make some body content
-        $body = $this->parseLibraryReferences($isPreview, $this->getRawNode('currentTemplate', null));
-        $dailyTemplate = $this->parseLibraryReferences($isPreview, $this->getRawNode('dailyTemplate', null));
-
         // Get the JavaScript node
         $javaScript = $this->parseLibraryReferences($isPreview, $this->getRawNode('javaScript', ''));
 
@@ -636,18 +630,20 @@
             'originalWidth' => $this->region->width,
             'originalHeight' => $this->region->height,
             'scaleOverride' => $this->getSanitizer()->getDouble('scale_override', 0),
-            'widgetDesignWidth' => $this->getSanitizer()->int($this->getOption('widgetOriginalWidth')),
-            'widgetDesignHeight'=> $this->getSanitizer()->int($this->getOption('widgetOriginalHeight'))
+            'widgetDesignWidth' => $widgetOriginalWidth,
+            'widgetDesignHeight'=> $widgetOriginalHeight
         );
 
         $javaScriptContent = '<script type="text/javascript" src="' . $this->getResourceUrl('vendor/jquery-1.11.1.min.js') . '"></script>';
         $javaScriptContent .= '<script type="text/javascript" src="' . $this->getResourceUrl('xibo-layout-scaler.js') . '"></script>';
+        $javaScriptContent .= '<script type="text/javascript" src="' . $this->getResourceUrl('xibo-image-render.js') . '"></script>';
         $javaScriptContent .= '<script>
 
             var options = ' . json_encode($options) . '
 
             $(document).ready(function() {
                 $("body").xiboLayoutScaler(options);
+                $("#content").find("img").xiboImageRender(options);
             });
         </script>';
         $javaScriptContent .= $javaScript;

=== modified file 'lib/Widget/ModuleWidget.php'
--- lib/Widget/ModuleWidget.php	2016-12-21 13:00:45 +0000
+++ lib/Widget/ModuleWidget.php	2017-01-23 15:46:25 +0000
@@ -999,6 +999,45 @@
     }
 
     /**
+     * Get templatesAvailable
+     * @return Templates
+     */
+    public function templatesAvailable()
+    {
+        if (!isset($this->module->settings['templates'])) {
+            
+            $this->module->settings['templates'] = [];
+
+            // Scan the folder for template files
+            foreach (glob(PROJECT_ROOT . '/modules/' . $this->module->type . '/*.template.json') as $template) {
+                // Read the contents, json_decode and add to the array
+                $this->module->settings['templates'][] = json_decode(file_get_contents($template), true);
+            }
+            
+        }
+            
+        return $this->module->settings['templates'];
+    }    
+    
+    /**
+     * Get by Template Id
+     * @param int $templateId
+     * @return Template
+     */
+    public function getTemplateById($templateId)
+    {
+        $templates = $this->templatesAvailable();
+        
+        foreach ($templates as $item) {
+            if( $item['id'] == $templateId ) {
+                $template = $item;
+            }
+        }
+        
+        return $template;
+    }
+
+    /**
      * Set template data
      * @param array $data
      * @return array

=== modified file 'lib/Widget/Stocks.php'
--- lib/Widget/Stocks.php	2016-11-16 11:49:12 +0000
+++ lib/Widget/Stocks.php	2017-01-23 15:46:25 +0000
@@ -73,36 +73,11 @@
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/vendor/jquery-1.11.1.min.js')->save();
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/xibo-finance-render.js')->save();
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/xibo-layout-scaler.js')->save();
+        $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/xibo-image-render.js')->save();
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/vendor/bootstrap.min.css')->save();
     }
 
     /**
-     * Loads templates for this module
-     */
-    private function loadTemplates()
-    {
-        $this->module->settings['templates'] = [];
-
-        // Scan the folder for template files
-        foreach (glob(PROJECT_ROOT . '/modules/stocks/*.template.json') as $template) {
-            // Read the contents, json_decode and add to the array
-            $this->module->settings['templates'][] = json_decode(file_get_contents($template), true);
-        }
-    }
-
-    /**
-     * Templates available
-     * @return array
-     */
-    public function templatesAvailable()
-    {
-        if (!isset($this->module->settings['templates']))
-            $this->loadTemplates();
-
-        return $this->module->settings['templates'];
-    }
-
-    /**
      * Form for updating the module settings
      */
     public function settingsForm()
@@ -123,6 +98,9 @@
 
     public function validate()
     {
+        if($this->getOption('overrideTemplate') == 0 && ( $this->getOption('templateId') == '' || $this->getOption('templateId') == null) )
+            throw new \InvalidArgumentException(__('Please choose a template'));
+            
         if ($this->getUseDuration() == 1 && $this->getDuration() == 0)
             throw new \InvalidArgumentException(__('Please enter a duration'));
     }
@@ -166,13 +144,16 @@
         $this->setOption('updateInterval', $this->getSanitizer()->getInt('updateInterval', 60));
         $this->setOption('templateId', $this->getSanitizer()->getString('templateId'));
         $this->setOption('durationIsPerPage', $this->getSanitizer()->getCheckbox('durationIsPerPage'));
-        $this->setOption('widgetOriginalWidth', $this->getSanitizer()->getInt('widgetOriginalWidth'));
-        $this->setOption('widgetOriginalHeight', $this->getSanitizer()->getInt('widgetOriginalHeight'));
-        $this->setOption('maxItemsPerPage', $this->getSanitizer()->getInt('maxItemsPerPage', 4));
-        $this->setRawNode('mainTemplate', $this->getSanitizer()->getParam('mainTemplate', $this->getSanitizer()->getParam('mainTemplate', null)));
-        $this->setRawNode('itemTemplate', $this->getSanitizer()->getParam('itemTemplate', $this->getSanitizer()->getParam('itemTemplate', null)));
-        $this->setRawNode('styleSheet', $this->getSanitizer()->getParam('styleSheet', $this->getSanitizer()->getParam('styleSheet', null)));
         $this->setRawNode('javaScript', $this->getSanitizer()->getParam('javaScript', ''));
+        
+        if( $this->getOption('overrideTemplate') == 1 ){
+            $this->setOption('widgetOriginalWidth', $this->getSanitizer()->getInt('widgetOriginalWidth'));
+            $this->setOption('widgetOriginalHeight', $this->getSanitizer()->getInt('widgetOriginalHeight'));
+            $this->setOption('maxItemsPerPage', $this->getSanitizer()->getInt('maxItemsPerPage', 4));
+            $this->setRawNode('mainTemplate', $this->getSanitizer()->getParam('mainTemplate', $this->getSanitizer()->getParam('mainTemplate', null)));
+            $this->setRawNode('itemTemplate', $this->getSanitizer()->getParam('itemTemplate', $this->getSanitizer()->getParam('itemTemplate', null)));
+            $this->setRawNode('styleSheet', $this->getSanitizer()->getParam('styleSheet', $this->getSanitizer()->getParam('styleSheet', null)));
+        }
     }
 
     /**
@@ -392,10 +373,33 @@
         if (!$items = $this->getYql()) {
             return '';
         }
+        
+        if( $this->getOption('overrideTemplate') == 0 ) {
+            
+            $template = $this->getTemplateById($this->getOption('templateId'));
+            
+            if (isset($template)) {
+                $mainTemplate = $template['main'];
+                $itemTemplate = $template['item'];
+                $styleSheet = $template['css'];
+                $widgetOriginalWidth = $template['widgetOriginalWidth'];
+                $widgetOriginalHeight = $template['widgetOriginalHeight'];
+                $maxItemsPerPage = $template['maxItemsPerPage'];
+            }
+            
+        } else {
+            
+            $mainTemplate = $this->getRawNode('mainTemplate');
+            $itemTemplate = $this->getRawNode('itemTemplate');
+            $styleSheet = $this->getRawNode('styleSheet', '');
+            $widgetOriginalWidth = $this->getSanitizer()->int($this->getOption('widgetOriginalWidth'));
+            $widgetOriginalHeight = $this->getSanitizer()->int($this->getOption('widgetOriginalHeight'));
+            $maxItemsPerPage = $this->getSanitizer()->int($this->getOption('maxItemsPerPage'));
+        }
 
         // Run through each item and substitute with the template
-        $mainTemplate = $this->parseLibraryReferences($isPreview, $this->getRawNode('mainTemplate'));
-        $itemTemplate = $this->parseLibraryReferences($isPreview, $this->getRawNode('itemTemplate'));
+        $mainTemplate = $this->parseLibraryReferences($isPreview, $mainTemplate);
+        $itemTemplate = $this->parseLibraryReferences($isPreview, $itemTemplate);
         
         $renderedItems = [];
         
@@ -414,10 +418,10 @@
             'originalHeight' => $this->region->height,
             'previewWidth' => $this->getSanitizer()->getDouble('width', 0),
             'previewHeight' => $this->getSanitizer()->getDouble('height', 0),
-            'widgetDesignWidth' => $this->getSanitizer()->int($this->getOption('widgetOriginalWidth')),
-            'widgetDesignHeight'=> $this->getSanitizer()->int($this->getOption('widgetOriginalHeight')),
+            'widgetDesignWidth' => $widgetOriginalWidth,
+            'widgetDesignHeight'=> $widgetOriginalHeight,
             'scaleOverride' => $this->getSanitizer()->getDouble('scale_override', 0), 
-            'maxItemsPerPage' => $this->getSanitizer()->int($this->getOption('maxItemsPerPage'))
+            'maxItemsPerPage' => $maxItemsPerPage
         );
 
         $itemsPerPage = $options['maxItemsPerPage'];
@@ -444,7 +448,7 @@
         }
         
         // Add the CSS if it isn't empty, and replace the wallpaper
-        $css = $this->makeSubstitutions([], $this->getRawNode('styleSheet', null), '');
+        $css = $this->makeSubstitutions([], $styleSheet, '');
 
         if ($css != '') {
             $headContent .= '<style type="text/css">' . $this->parseLibraryReferences($isPreview, $css) . '</style>';
@@ -461,13 +465,14 @@
 
         $javaScriptContent .= '<script type="text/javascript" src="' . $this->getResourceUrl('xibo-layout-scaler.js') . '"></script>';
         $javaScriptContent .= '<script type="text/javascript" src="' . $this->getResourceUrl('xibo-finance-render.js') . '"></script>';
+        $javaScriptContent .= '<script type="text/javascript" src="' . $this->getResourceUrl('xibo-image-render.js') . '"></script>';
 
         $javaScriptContent .= '<script type="text/javascript">';
         $javaScriptContent .= '   var options = ' . json_encode($options) . ';';
         $javaScriptContent .= '   var items = ' . json_encode($renderedItems) . ';';
         $javaScriptContent .= '   var body = ' . json_encode($mainTemplate) . ';';
         $javaScriptContent .= '   $(document).ready(function() { ';
-        $javaScriptContent .= '       $("body").xiboLayoutScaler(options); $("#content").xiboFinanceRender(options, items, body); ';
+        $javaScriptContent .= '       $("body").xiboLayoutScaler(options); $("#content").xiboFinanceRender(options, items, body); $("#content").find("img").xiboImageRender(options); ';
         $javaScriptContent .= '   }); ';
         $javaScriptContent .= $javaScript;
         $javaScriptContent .= '</script>';

=== modified file 'lib/Widget/Text.php'
--- lib/Widget/Text.php	2016-06-10 12:33:40 +0000
+++ lib/Widget/Text.php	2017-01-11 15:28:44 +0000
@@ -34,6 +34,7 @@
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/vendor/jquery.marquee.min.js')->save();
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/xibo-layout-scaler.js')->save();
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/xibo-text-render.js')->save();
+        $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/xibo-image-render.js')->save();
     }
 
     public function validate()
@@ -181,6 +182,7 @@
 
         $javaScriptContent .= '<script type="text/javascript" src="' . $this->getResourceUrl('xibo-layout-scaler.js') . '"></script>';
         $javaScriptContent .= '<script type="text/javascript" src="' . $this->getResourceUrl('xibo-text-render.js') . '"></script>';
+        $javaScriptContent .= '<script type="text/javascript" src="' . $this->getResourceUrl('xibo-image-render.js') . '"></script>';
 
         // Do we need to include moment?
         if ($clock)
@@ -190,7 +192,7 @@
         $javaScriptContent .= '   var options = ' . json_encode($options) . ';';
         $javaScriptContent .= '   var items = ' . json_encode($items) . ';';
         $javaScriptContent .= '   $(document).ready(function() { ';
-        $javaScriptContent .= '       $("#content").xiboTextRender(options, items); $("body").xiboLayoutScaler(options);';
+        $javaScriptContent .= '       $("#content").xiboTextRender(options, items); $("body").xiboLayoutScaler(options); $("#content").find("img").xiboImageRender(options); ';
 
         if ($clock)
             $javaScriptContent .= ' moment.locale("' . Translate::GetJsLocale() . '"); updateClock(); setInterval(updateClock, 1000); ';

=== modified file 'lib/Widget/Ticker.php'
--- lib/Widget/Ticker.php	2017-01-04 15:21:57 +0000
+++ lib/Widget/Ticker.php	2017-02-14 08:43:20 +0000
@@ -44,6 +44,7 @@
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/vendor/jquery-cycle-2.1.6.min.js')->save();
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/xibo-layout-scaler.js')->save();
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/xibo-text-render.js')->save();
+        $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/xibo-image-render.js')->save();
     }
 
     /**
@@ -115,32 +116,6 @@
         }
     }
 
-    /**
-     * Loads templates for this module
-     */
-    private function loadTemplates()
-    {
-        // Scan the folder for template files
-        foreach (glob(PROJECT_ROOT . '/modules/ticker/*.template.json') as $template) {
-            // Read the contents, json_decode and add to the array
-            $this->module->settings['templates'][] = json_decode(file_get_contents($template), true);
-        }
-
-        $this->getLog()->debug(count($this->module->settings['templates']));
-    }
-
-    /**
-     * Templates available
-     * @return array
-     */
-    public function templatesAvailable()
-    {
-        if (!isset($this->module->settings['templates']))
-            $this->loadTemplates();
-
-        return $this->module->settings['templates'];
-    }
-
     public function validate()
     {
         // Must have a duration
@@ -312,10 +287,12 @@
             $this->setOption('filterClauses', json_encode($filterClauseMapping));
         }
 
-        // Text Template
-        $this->setRawNode('template', $this->getSanitizer()->getParam('ta_text', $this->getSanitizer()->getParam('template', null)));
-        $this->setRawNode('css', $this->getSanitizer()->getParam('ta_css', $this->getSanitizer()->getParam('css', null)));
-
+        if( $this->getOption('overrideTemplate') == 1 ){
+            // Text Template
+            $this->setRawNode('template', $this->getSanitizer()->getParam('ta_text', $this->getSanitizer()->getParam('template', null)));
+            $this->setRawNode('css', $this->getSanitizer()->getParam('ta_css', $this->getSanitizer()->getParam('css', null)));
+        }
+        
         // Save the widget
         $this->validate();
         $this->saveWidget();
@@ -379,11 +356,25 @@
         $takeItemsFrom = $this->getOption('takeItemsFrom', 'start');
         $itemsPerPage = $this->getOption('itemsPerPage', 0);
 
-        // Get the text out of RAW
-        $text = $this->parseLibraryReferences($isPreview, $this->getRawNode('template', null));
+        // Get CSS and HTML template from the original template or from the input field
+        if( $this->getOption('overrideTemplate') == 0 ) {
+            
+            $template = $this->getTemplateById($this->getOption('templateId'));
+            
+            if (isset($template)) {
+                $text = $template['template'];
+                $css = $template['css'];
+            }
+        } else {
+                $text = $this->getRawNode('template', '');
+                $css = $this->getRawNode('css', '');
+        }
+        
+        // Parse library references on the template
+        $text = $this->parseLibraryReferences($isPreview, $text);
 
-        // Get the CSS Node
-        $css = $this->parseLibraryReferences($isPreview, $this->getRawNode('css', ''));
+        // Parse library references on the CSS Node
+        $css = $this->parseLibraryReferences($isPreview, $css);
 
         // Get the JavaScript node
         $javaScript = $this->parseLibraryReferences($isPreview, $this->getRawNode('javaScript', ''));
@@ -492,12 +483,13 @@
 
         $javaScriptContent .= '<script type="text/javascript" src="' . $this->getResourceUrl('xibo-layout-scaler.js') . '"></script>';
         $javaScriptContent .= '<script type="text/javascript" src="' . $this->getResourceUrl('xibo-text-render.js') . '"></script>';
+        $javaScriptContent .= '<script type="text/javascript" src="' . $this->getResourceUrl('xibo-image-render.js') . '"></script>';
 
         $javaScriptContent .= '<script type="text/javascript">';
         $javaScriptContent .= '   var options = ' . json_encode($options) . ';';
         $javaScriptContent .= '   var items = ' . json_encode($items) . ';';
         $javaScriptContent .= '   $(document).ready(function() { ';
-        $javaScriptContent .= '       $("body").xiboLayoutScaler(options); $("#content").xiboTextRender(options, items);';
+        $javaScriptContent .= '       $("body").xiboLayoutScaler(options); $("#content").xiboTextRender(options, items); $("#content").find("img").xiboImageRender(options); ';
         $javaScriptContent .= '   }); ';
         $javaScriptContent .= $javaScript;
         $javaScriptContent .= '</script>';

=== modified file 'lib/Widget/Twitter.php'
--- lib/Widget/Twitter.php	2017-01-13 11:20:02 +0000
+++ lib/Widget/Twitter.php	2017-01-23 15:46:25 +0000
@@ -85,6 +85,7 @@
     {
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/vendor/jquery-1.11.1.min.js')->save();
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/xibo-text-render.js')->save();
+        $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/xibo-image-render.js')->save();
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/xibo-layout-scaler.js')->save();
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/emojione/emojione.sprites.svg')->save();
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/vendor/bootstrap.min.css')->save();
@@ -96,34 +97,6 @@
     }
 
     /**
-     * Loads templates for this module
-     */
-    private function loadTemplates()
-    {
-        $this->module->settings['templates'] = [];
-
-        // Scan the folder for template files
-        foreach (glob(PROJECT_ROOT . '/modules/twitter/*.template.json') as $template) {
-            // Read the contents, json_decode and add to the array
-            $this->module->settings['templates'][] = json_decode(file_get_contents($template), true);
-        }
-
-        $this->getLog()->debug(count($this->module->settings['templates']));
-    }
-
-    /**
-     * Templates available
-     * @return array
-     */
-    public function templatesAvailable()
-    {
-        if (!isset($this->module->settings['templates']))
-            $this->loadTemplates();
-
-        return $this->module->settings['templates'];
-    }
-
-    /**
      * Form for updating the module settings
      */
     public function settingsForm()
@@ -159,6 +132,10 @@
 
     public function validate()
     {
+        // If overrideTemplate is false we have to define a template Id 
+        if($this->getOption('overrideTemplate') == 0 && ( $this->getOption('templateId') == '' || $this->getOption('templateId') == null) )
+            throw new \InvalidArgumentException(__('Please choose a template'));
+            
         if ($this->getUseDuration() == 1 && $this->getDuration() == 0)
             throw new \InvalidArgumentException(__('Please enter a duration'));
 
@@ -214,14 +191,19 @@
         $this->setOption('updateInterval', $this->getSanitizer()->getInt('updateInterval', 60));
         $this->setOption('templateId', $this->getSanitizer()->getString('templateId'));
         $this->setOption('durationIsPerItem', $this->getSanitizer()->getCheckbox('durationIsPerItem'));
-        $this->setOption('itemsPerPage', $this->getSanitizer()->getInt('itemsPerPage', 5));
-        $this->setOption('widgetOriginalPadding', $this->getSanitizer()->getInt('widgetOriginalPadding'));
-        $this->setOption('widgetOriginalWidth', $this->getSanitizer()->getInt('widgetOriginalWidth'));
-        $this->setOption('widgetOriginalHeight', $this->getSanitizer()->getInt('widgetOriginalHeight'));
-        $this->setOption('resultContent', $this->getSanitizer()->getString('resultContent'));
-        $this->setRawNode('template', $this->getSanitizer()->getParam('ta_text', $this->getSanitizer()->getParam('template', null)));
-        $this->setRawNode('styleSheet', $this->getSanitizer()->getParam('ta_css', $this->getSanitizer()->getParam('styleSheet', null)));
+        $this->setOption('itemsPerPage', $this->getSanitizer()->getInt('itemsPerPage'), 5);
         $this->setRawNode('javaScript', $this->getSanitizer()->getParam('javaScript', ''));
+        
+        if( $this->getOption('overrideTemplate') == 1 ){
+            $this->setRawNode('template', $this->getSanitizer()->getParam('ta_text', $this->getSanitizer()->getParam('template', null)));
+            $this->setRawNode('styleSheet', $this->getSanitizer()->getParam('ta_css', $this->getSanitizer()->getParam('styleSheet', null)));
+            $this->setOption('resultContent', $this->getSanitizer()->getString('resultContent'));
+                
+            $this->setOption('widgetOriginalPadding', $this->getSanitizer()->getInt('widgetOriginalPadding'));
+            $this->setOption('widgetOriginalWidth', $this->getSanitizer()->getInt('widgetOriginalWidth'));
+            $this->setOption('widgetOriginalHeight', $this->getSanitizer()->getInt('widgetOriginalHeight'));
+        }
+        
     }
 
     /**
@@ -254,10 +236,22 @@
             $geoCode = implode(',', array($defaultLat, $defaultLong, $distance)) . 'mi';
         }
         
+        if( $this->getOption('overrideTemplate') == 0 ) {
+            
+            $tmplt = $this->getTemplateById($this->getOption('templateId'));
+            
+            if (isset($tmplt)) {
+                $template = $tmplt['template'];
+                $resultContent = $tmplt['resultContent'];
+            }
+            
+        } else {
+            $template = $this->getRawNode('template', null);
+            $resultContent = $this->getOption('resultContent');
+        }
         
         // Search content filtered by type of tweets  
         $searchTerm = $this->getOption('searchTerm');
-        $resultContent = $this->getOption('resultContent');
         
         switch ($resultContent) {
           case 0:
@@ -304,7 +298,7 @@
         }
 
         // Get the template
-        $template = $this->parseLibraryReferences($isPreview, $this->getRawNode('template', null));
+        $template = $this->parseLibraryReferences($isPreview, $template);
 
         // Parse the text template
         $matches = '';
@@ -518,6 +512,26 @@
         $numItems = $this->getOption('numItems', 0);
         $itemsPerPage = $this->getOption('itemsPerPage', 0);
         $durationIsPerItem = $this->getOption('durationIsPerItem', 1);
+        
+        if( $this->getOption('overrideTemplate') == 0 ) {
+            
+            $template = $this->getTemplateById($this->getOption('templateId'));
+            
+            if (isset($template)) {
+                $css = $template['css'];
+                $widgetOriginalWidth = $template['widgetOriginalWidth'];
+                $widgetOriginalHeight = $template['widgetOriginalHeight'];
+                $widgetOriginalPadding = $template['widgetOriginalPadding'];
+                $resultContent = $template['resultContent'];
+            }
+            
+        } else {
+            $css = $this->getRawNode('styleSheet', '');
+            $widgetOriginalWidth = $this->getSanitizer()->int($this->getOption('widgetOriginalWidth'));
+            $widgetOriginalHeight = $this->getSanitizer()->int($this->getOption('widgetOriginalHeight'));
+            $widgetOriginalPadding = $this->getSanitizer()->int($this->getOption('widgetOriginalPadding'));
+            $resultContent = $this->getOption('resultContent');
+        }
 
         // Generate a JSON string of substituted items.
         $items = $this->getTwitterFeed($displayId, $isPreview);
@@ -538,10 +552,9 @@
             'previewWidth' => $this->getSanitizer()->getDouble('width', 0),
             'previewHeight' => $this->getSanitizer()->getDouble('height', 0),
             'scaleOverride' => $this->getSanitizer()->getDouble('scale_override', 0),
-            'widgetDesignPadding' => $this->getSanitizer()->int($this->getOption('widgetOriginalPadding')),
-            'widgetDesignWidth' => $this->getSanitizer()->int($this->getOption('widgetOriginalWidth')),
-            'widgetDesignHeight'=> $this->getSanitizer()->int($this->getOption('widgetOriginalHeight')),
-            'resultContent'=> $this->getSanitizer()->string($this->getOption('resultContent')),
+            'widgetDesignPadding' => $widgetOriginalPadding,
+            'widgetDesignWidth' => $widgetOriginalWidth,
+            'widgetDesignHeight'=> $widgetOriginalHeight,
             'itemsPerPage' => $this->getSanitizer()->int($this->getOption('itemsPerPage', 5))
         );
 
@@ -573,7 +586,6 @@
         <link href="' . $this->getResourceUrl('vendor/bootstrap.min.css')  . '" rel="stylesheet" media="screen">';
         
         // Add the CSS if it isn't empty
-        $css = $this->getRawNode('styleSheet', null);
         if ($css != '') {
             $headContent .= '<style type="text/css">' . $this->parseLibraryReferences($isPreview, $css) . '</style>';
         }
@@ -591,12 +603,13 @@
 
         $javaScriptContent .= '<script type="text/javascript" src="' . $this->getResourceUrl('xibo-layout-scaler.js') . '"></script>';
         $javaScriptContent .= '<script type="text/javascript" src="' . $this->getResourceUrl('xibo-text-render.js') . '"></script>';
+        $javaScriptContent .= '<script type="text/javascript" src="' . $this->getResourceUrl('xibo-image-render.js') . '"></script>';
 
         $javaScriptContent .= '<script type="text/javascript">';
         $javaScriptContent .= '   var options = ' . json_encode($options) . ';';
         $javaScriptContent .= '   var items = ' . json_encode($items) . ';';
         $javaScriptContent .= '   $(document).ready(function() { ';
-        $javaScriptContent .= '       $("body").xiboLayoutScaler(options); $("#content").xiboTextRender(options, items); ';
+        $javaScriptContent .= '       $("body").xiboLayoutScaler(options); $("#content").xiboTextRender(options, items); $("img").xiboImageRender(options);';
         $javaScriptContent .= '   }); ';
         $javaScriptContent .= $javaScript;
         $javaScriptContent .= '</script>';

=== modified file 'lib/Widget/TwitterMetro.php'
--- lib/Widget/TwitterMetro.php	2016-11-16 11:51:16 +0000
+++ lib/Widget/TwitterMetro.php	2017-01-18 16:10:32 +0000
@@ -87,6 +87,7 @@
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/vendor/jquery-1.11.1.min.js')->save();
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/xibo-metro-render.js')->save();
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/xibo-layout-scaler.js')->save();
+        $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/xibo-image-render.js')->save();
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/emojione/emojione.sprites.svg')->save();
         $this->mediaFactory->createModuleSystemFile(PROJECT_ROOT . '/web/modules/vendor/bootstrap.min.css')->save();
         
@@ -185,6 +186,10 @@
 
     public function validate()
     {
+        // If overrideColorTemplate is false we have to define a template Id 
+        if($this->getOption('overrideColorTemplate') == 0 && ( $this->getOption('colorTemplateId') == '' || $this->getOption('colorTemplateId') == null) )
+            throw new \InvalidArgumentException(__('Please choose a template'));
+            
         if ($this->getUseDuration() == 1 && $this->getDuration() == 0)
             throw new \InvalidArgumentException(__('Please enter a duration'));
 
@@ -242,13 +247,16 @@
         $this->setOption('resultContent', $this->getSanitizer()->getString('resultContent'));
         $this->setOption('removeRetweets', $this->getSanitizer()->getCheckbox('removeRetweets'));
         
-        // Convert the colors array to string to be able to save it
-        $stringColor = $this->getSanitizer()->getStringArray('color')[0];
-        for ($i=1; $i < count($this->getSanitizer()->getStringArray('color')); $i++) {
-            if(!empty($this->getSanitizer()->getStringArray('color')[$i]))
-                $stringColor .= "|" . $this->getSanitizer()->getStringArray('color')[$i];
+        if( $this->getOption('overrideColorTemplate') == 1 ){
+            
+            // Convert the colors array to string to be able to save it
+            $stringColor = $this->getSanitizer()->getStringArray('color')[0];
+            for ($i=1; $i < count($this->getSanitizer()->getStringArray('color')); $i++) {
+                if(!empty($this->getSanitizer()->getStringArray('color')[$i]))
+                    $stringColor .= "|" . $this->getSanitizer()->getStringArray('color')[$i];
+            }
+            $this->setOption('templateColours', $stringColor);
         }
-        $this->setOption('templateColours', $stringColor);
     }
 
     /**
@@ -478,7 +486,19 @@
                         if (!$this->tweetHasPhoto($tweet)) {
                         
                             // Get the colors array
-                            $colorArray = explode("|", $this->getOption('templateColours'));
+                            if( $this->getOption('overrideColorTemplate') == 0 ) {
+                                
+                                $templates = $this->colorTemplatesAvailable();
+                                
+                                foreach ($templates as $tmplt) {
+                                    if( $tmplt['id'] == $this->getOption('colorTemplateId') ){
+                                        $colorArray = $tmplt['colors'];
+                                    }
+                                }
+                                
+                            } else {
+                                $colorArray = explode("|", $this->getOption('templateColours'));
+                            }
                             
                             // Find a random color
                             $randomNum = rand(0,count($colorArray)-1);
@@ -623,7 +643,19 @@
         $javaScriptContent = '<script type="text/javascript" src="' . $this->getResourceUrl('vendor/jquery-1.11.1.min.js') . '"></script>';
 
         // Get the colors array
-        $colorArray = explode("|", $this->getOption('templateColours'));
+        if( $this->getOption('overrideColorTemplate') == 0 ) {
+            
+            $templates = $this->colorTemplatesAvailable();
+            
+            foreach ($templates as $tmplt) {
+                if( $tmplt['id'] == $this->getOption('colorTemplateId') ){
+                    $colorArray = $tmplt['colors'];
+                }
+            }
+            
+        } else {
+            $colorArray = explode("|", $this->getOption('templateColours'));
+        }
         
         // Need the cycle plugin?
         if ($this->getOption('effect') != 'none')
@@ -631,13 +663,14 @@
 
         $javaScriptContent .= '<script type="text/javascript" src="' . $this->getResourceUrl('xibo-layout-scaler.js') . '"></script>';
         $javaScriptContent .= '<script type="text/javascript" src="' . $this->getResourceUrl('xibo-metro-render.js') . '"></script>';
+        $javaScriptContent .= '<script type="text/javascript" src="' . $this->getResourceUrl('xibo-image-render.js') . '"></script>';
 
         $javaScriptContent .= '<script type="text/javascript">';
         $javaScriptContent .= '   var options = ' . json_encode($options) . ';';
         $javaScriptContent .= '   var items = ' . json_encode($items) . ';';
         $javaScriptContent .= '   var colors = ' . json_encode($colorArray) . ';';
         $javaScriptContent .= '   $(document).ready(function() { ';
-        $javaScriptContent .= '       $("body").xiboLayoutScaler(options); $("#content").xiboMetroRender(options, items, colors); ';
+        $javaScriptContent .= '       $("body").xiboLayoutScaler(options); $("#content").xiboMetroRender(options, items, colors); $("#content").find("img").xiboImageRender(options); $("#content").find(".cell").xiboImageRender(options);';
         $javaScriptContent .= '   }); ';
         $javaScriptContent .= '</script>';
 

=== modified file 'modules/currencies-form-add.twig'
--- modules/currencies-form-add.twig	2016-11-16 11:49:12 +0000
+++ modules/currencies-form-add.twig	2017-01-05 11:22:28 +0000
@@ -168,6 +168,10 @@
                         {% set helpText %}{% trans "The base currency." %}{% endset %}
                         {{ forms.input("base", title, "", helpText, "", "required") }}
                         
+                        {% set title %}{% trans "Reverse conversion?" %}{% endset %}
+                        {% set helpText %}{% trans "Tick if you would like your base currency to be used as the comparison currency for each currency you've entered. For example base/compare becomes compare/base - USD/GBP becomes GBP/USD." %}{% endset %}
+                        {{ forms.checkbox("reverseConversion", title, 0, helpText) }}
+
                         {% set title %}{% trans "Override the template?" %}{% endset %}
                         {% set helpText %}{% trans "Tick if you would like to override the template." %}{% endset %}
                         {{ forms.checkbox("overrideTemplate", title, module.getOption("overrideTemplate", 0), helpText) }}

=== modified file 'modules/currencies-form-edit.twig'
--- modules/currencies-form-edit.twig	2016-11-16 11:49:12 +0000
+++ modules/currencies-form-edit.twig	2017-01-05 11:22:28 +0000
@@ -169,6 +169,10 @@
                         {% set title %}{% trans "Base" %}{% endset %}
                         {% set helpText %}{% trans "The base currency." %}{% endset %}
                         {{ forms.input("base", title, module.getOption("base"), helpText, "", "required") }}
+                        
+                        {% set title %}{% trans "Reverse conversion?" %}{% endset %}
+                        {% set helpText %}{% trans "Tick if you would like your base currency to be used as the comparison currency for each currency you've entered. For example base/compare becomes compare/base - USD/GBP becomes GBP/USD." %}{% endset %}
+                        {{ forms.checkbox("reverseConversion", title, module.getOption("reverseConversion", 0), helpText) }}
 
                         {% set title %}{% trans "Override the template?" %}{% endset %}
                         {% set helpText %}{% trans "Tick if you would like to override the template." %}{% endset %}

=== modified file 'modules/currencies/currencies1.template.json'
--- modules/currencies/currencies1.template.json	2016-11-16 11:49:12 +0000
+++ modules/currencies/currencies1.template.json	2017-01-06 11:22:58 +0000
@@ -2,7 +2,7 @@
     "id": "currencies1",
     "value": "Currencies 1",
     "main": "<div class=\"container-main\">\r\n    <div class=\"container \">\r\n        <div class=\"row row-header\">\r\n            <div class=\"col-xs-2 col-xs-offset-7 text-center value\">BUY<\/div>\r\n            <div class=\"col-xs-2 col-xs-offset-1 value text-center\">SELL<\/div>\r\n        <\/div>\r\n        <div id=\"cycle-container\">\r\n            [itemsTemplate]\r\n        <\/div>\r\n    <\/div>\r\n<\/div>",
-    "item": "<div class=\"row row-finance\">\r\n    <div class=\"col-xs-1 flags\">\r\n        <img class=\"img-circle center-block \" src=\"[CurrencyFlag]\">\r\n    <\/div>\r\n    <div class=\"col-xs-1 value \">[NameShort]<\/div>\r\n    <div class=\"col-xs-2 col-xs-offset-5 text-center value\">[Bid]<\/div>\r\n    <div class=\"col-xs-2 col-xs-offset-1 value text-center\">[Ask]<\/div>\r\n<\/div>",
+    "item": "<div class=\"row row-finance\">\r\n    <div class=\"col-xs-1 flags\">\r\n        <img class=\"img-circle center-block \" src=\"[CurrencyFlag]\">\r\n    <\/div>\r\n    <div class=\"col-xs-3 value \">[NameShort]<\/div>\r\n    <div class=\"col-xs-2 col-xs-offset-3 text-center value\">[BidValue]<\/div>\r\n    <div class=\"col-xs-2 col-xs-offset-1 value text-center\">[AskValue]<\/div>\r\n<\/div>",
     "css": "body {\r\n    font-family: \"Helvetica\", \"Arial\", sans-serif;\r\n    line-height: 1;\r\n}\r\n\r\n.container-main {\r\n    height: 420px !important;\r\n    width: 820px !important;\r\n}\r\n\r\n.container {\r\n    height: 420px !important;\r\n    width: 820px !important;\r\n    float: left;\r\n    margin-top: 20px;\r\n}\r\n\r\n.row-finance {\r\n    height: 60px;\r\n    background: rgba(0, 0, 0, 0.87);\r\n    margin-bottom: 20px;\r\n}\r\n\r\n.row {\r\n    margin-right: 0;\r\n    margin-left: 0;\r\n}\r\n\r\n.row-header {\r\n    margin-right: -15px;\r\n    margin-left: -15px;\r\n    margin-bottom: 20px;\r\n}\r\n\r\n#cycle-container {\r\n    margin-left: -15px;\r\n    margin-right: -15px;\r\n}\r\n\r\n.value {\r\n    font-size: 20px;\r\n    padding-top: 20px;\r\n    font-weight: bold;\r\n    color: #fff;\r\n}\r\n\r\n.down-arrow {\r\n    font-size: 20px;\r\n    color: red;\r\n    padding-top: 17px;\r\n}\r\n\r\n.up-arrow {\r\n    font-size: 20px;\r\n    color: green;\r\n    padding-top: 17px;\r\n}\r\n\r\n.variant {\r\n    font-size: 20px;\r\n    padding-top: 17px;\r\n}\r\n\r\n.flags {\r\n    padding-top: 4px;\r\n}\r\n\r\n.center-block {\r\n    width: 50px;\r\n    height: 50px;\r\n}",
     "maxItemsPerPage": 4,
     "widgetOriginalWidth": "820",

=== modified file 'modules/currencies/currencies2.template.json'
--- modules/currencies/currencies2.template.json	2016-11-16 11:49:12 +0000
+++ modules/currencies/currencies2.template.json	2017-01-06 11:22:58 +0000
@@ -2,7 +2,7 @@
     "id": "currencies2",
     "value": "Currencies 2",
     "main": "<div class=\"container-main\">\r\n    <div class=\"container \">\r\n        <div id=\"cycle-container\">\r\n            [itemsTemplate]\r\n        <\/div>\r\n    <\/div>\r\n<\/div>",
-    "item": "<div class=\"row row-finance\">\r\n     <div class=\"col-xs-1 flags\">\r\n        <img class=\"img-circle center-block \" src=\"[CurrencyFlag]\">\r\n    <\/div>\r\n    <div class=\"col-xs-5 value \">[NameShort]<\/div>\r\n    <div class=\"col-xs-3 text-right value\">[LastTradePriceOnly] [CurrencyUpper]<\/div>\r\n    <div class=\"col-xs-2 text-right value [ChangeStyle]\">[ChangePercentage]%<\/div>\r\n    <div class=\"col-xs-1 text-right\"><div class=\"[ChangeIcon]\"><\/div><\/div>\r\n<\/div>",
+    "item": "<div class=\"row row-finance\">\r\n     <div class=\"col-xs-1 flags\">\r\n        <img class=\"img-circle center-block \" src=\"[CurrencyFlag]\">\r\n    <\/div>\r\n    <div class=\"col-xs-5 value \">[NameShort]<\/div>\r\n    <div class=\"col-xs-3 text-right value\">[LastTradePriceOnlyValue]<\/div>\r\n    <div class=\"col-xs-2 text-right value [ChangeStyle]\">[ChangePercentage]%<\/div>\r\n    <div class=\"col-xs-1 text-right\"><div class=\"[ChangeIcon]\"><\/div><\/div>\r\n<\/div>",
     "css": "body {\r\n    font-family: \"Helvetica\", \"Arial\", sans-serif;\r\n    line-height: 1;\r\n}\r\n\r\n.img-circle {\r\n    width: 52px;\r\n}\r\n\r\n.container-main {\r\n    height: 420px !important;\r\n    width: 820px !important;\r\n}\r\n.container {\r\n    width: 820px !important;\r\n    height: 420px !important;\r\n    float: left;\r\n    margin-top: 25px;\r\n}\r\n.row-finance {\r\n    height: 60px;\r\n    background: #e0e0e0;\r\n    margin-bottom: 17px;\r\n    border-left: #264a88 10px solid;\r\n}\r\n.row {\r\n    margin-right: 0;\r\n    margin-left: 0;\r\n}\r\n\r\n#cycle-container {\r\n    margin-left: -15px;\r\n    margin-right: -15px;\r\n}\r\n.value {\r\nfont-size: 20px;\r\n    padding-top: 20px;;\r\n    color: #000;\r\n    white-space: nowrap;\r\n}\r\n.down-arrow {\r\n    margin: 25px 0px 0px 20px;\r\n    width: 0;\r\n    height: 0;\r\n    border-left: 10px solid transparent;\r\n    border-right: 10px solid transparent;\r\n    border-top: 10px solid red;\r\n}\r\n.up-arrow {\r\n    margin: 25px 0px 0px 20px;\r\n    width: 0;\r\n    height: 0;\r\n    border-left: 10px solid transparent;\r\n    border-right: 10px solid transparent;\r\n    border-bottom: 10px solid green;\r\n}\r\n.right-arrow {\r\n    margin: 20px 0px 0px 25px;\r\n    width: 0;\r\n    height: 0;\r\n    border-left: 10px solid gray;\r\n    border-top: 10px solid transparent;\r\n    border-bottom: 10px solid transparent;\r\n}\r\n.variant {\r\n    font-size: 20px;\r\n    padding-top: 17px;\r\n}\r\n.flags {\r\n    padding-top: 4px;\r\n}\r\n.value-up {\r\n    color: green;\r\n    font-weight: bold\r\n}\r\n.value-down {\r\n    color: red;\r\n    font-weight: bold\r\n}\r\n.value-equal {\r\n    color: gray;\r\n    font-weight: bold\r\n}\r\n.name-stock {\r\n    color: gray;\r\n}",
     "maxItemsPerPage": 5,
     "widgetOriginalWidth": "820",

=== modified file 'modules/datasetview-designer-javascript.twig'
--- modules/datasetview-designer-javascript.twig	2016-05-18 14:47:17 +0000
+++ modules/datasetview-designer-javascript.twig	2017-01-04 16:17:20 +0000
@@ -312,8 +312,13 @@
     }
 
     function DataSetViewSubmit(apply) {
+
         var form = $("#dataSetViewEditForm");
+        
+        // Clean the previous generated hidden dataSetColumns from the form
+        form.find('input[name="dataSetColumnId[]"]').remove();
 
+        // Add all the selected columns to the form as hidden input fields
         $($("#columnsIn").sortable('toArray')).each(function() {
             form.append('<input type="hidden" name="dataSetColumnId[]" value="' + this + '" />');
         });

=== modified file 'modules/forecastio-form-add.twig'
--- modules/forecastio-form-add.twig	2016-10-14 15:32:34 +0000
+++ modules/forecastio-form-add.twig	2017-01-24 17:04:44 +0000
@@ -58,38 +58,6 @@
     ".locationControls": { "display": "none" }
     }
     },{
-    "field": "templateId",
-    "trigger": "init",
-    "value": "picture",
-    "operation": "equals",
-    "actions": {
-    ".icon-controls": { "display": "block" }
-    }
-    },{
-    "field": "templateId",
-    "trigger": "change",
-    "value": "picture",
-    "operation": "equals",
-    "actions": {
-    ".icon-controls": { "display": "block" }
-    }
-    },{
-    "field": "templateId",
-    "trigger": "init",
-    "value": "picture",
-    "operation": "not",
-    "actions": {
-    ".icon-controls": { "display": "none" }
-    }
-    },{
-    "field": "templateId",
-    "trigger": "change",
-    "value": "picture",
-    "operation": "not",
-    "actions": {
-    ".icon-controls": { "display": "none" }
-    }
-    },{
     "field": "overrideTemplate",
     "trigger": "init",
     "value": false,
@@ -206,10 +174,6 @@
                         {% set helpText %}{% trans "Select the template you would like to apply. This can be overridden using the check box below." %}{% endset %}
                         {{ forms.dropdown("templateId", "single", title, module.getOption("templateId"), module.templatesAvailable(), "id", "value", helpText, "template-selector-control selectPicker selectPickerWithImage", null, null, null, null, null, baseUrl, "image") }}
 
-                        {% set title %}{% trans "Icons" %}{% endset %}
-                        {% set helpText %}{% trans "Select the icon set you would like to use." %}{% endset %}
-                        {{ forms.dropdown("icons", "single", title, module.getOption("icons"), module.iconsAvailable(), "id", "value", helpText, "icon-controls") }}
-
                         {% set title %}{% trans "Override the template?" %}{% endset %}
                         {% set helpText %}{% trans "Tick if you would like to override the template." %}{% endset %}
                         {{ forms.checkbox("overrideTemplate", title, 0, helpText) }}

=== modified file 'modules/forecastio-form-edit.twig'
--- modules/forecastio-form-edit.twig	2016-10-14 15:32:34 +0000
+++ modules/forecastio-form-edit.twig	2017-01-24 17:04:44 +0000
@@ -60,38 +60,6 @@
     ".locationControls": { "display": "none" }
     }
     },{
-    "field": "templateId",
-    "trigger": "init",
-    "value": "picture",
-    "operation": "equals",
-    "actions": {
-    ".icon-controls": { "display": "block" }
-    }
-    },{
-    "field": "templateId",
-    "trigger": "change",
-    "value": "picture",
-    "operation": "equals",
-    "actions": {
-    ".icon-controls": { "display": "block" }
-    }
-    },{
-    "field": "templateId",
-    "trigger": "init",
-    "value": "picture",
-    "operation": "not",
-    "actions": {
-    ".icon-controls": { "display": "none" }
-    }
-    },{
-    "field": "templateId",
-    "trigger": "change",
-    "value": "picture",
-    "operation": "not",
-    "actions": {
-    ".icon-controls": { "display": "none" }
-    }
-    },{
     "field": "overrideTemplate",
     "trigger": "init",
     "value": false,
@@ -209,10 +177,6 @@
                         {% set helpText %}{% trans "Select the template you would like to apply. This can be overridden using the check box below." %}{% endset %}
                         {{ forms.dropdown("templateId", "single", title, module.getOption("templateId"), module.templatesAvailable(), "id", "value", helpText, "template-selector-control selectPicker selectPickerWithImage", null, null, null, null, null, baseUrl, "image") }}
 
-                        {% set title %}{% trans "Icons" %}{% endset %}
-                        {% set helpText %}{% trans "Select the icon set you would like to use." %}{% endset %}
-                        {{ forms.dropdown("icons", "single", title, module.getOption("icons"), module.iconsAvailable(), "id", "value", helpText, "icon-controls") }}
-
                         {% set title %}{% trans "Override the template?" %}{% endset %}
                         {% set helpText %}{% trans "Tick if you would like to override the template." %}{% endset %}
                         {{ forms.checkbox("overrideTemplate", title, module.getOption("overrideTemplate"), helpText) }}

=== modified file 'modules/layout-preview.twig'
--- modules/layout-preview.twig	2016-06-08 14:41:13 +0000
+++ modules/layout-preview.twig	2017-01-24 14:48:47 +0000
@@ -16,6 +16,7 @@
         
         <link rel="shortcut icon" href="{{ theme.uri("img/favicon.ico") }}" />
         <link rel="stylesheet" type="text/css" href="{{ theme.uri("css/html-preview.css") }}" />
+        <link rel="stylesheet" type="text/css" href="{{ theme.uri("libraries/font-awesome/css/font-awesome.min.css") }}" />
         
     </head>
     <body>
@@ -24,6 +25,9 @@
         <script src="{{ theme.uri("libraries/html5preloader/html5Preloader.js") }}"></script>
         <script src="{{ theme.uri("js/html-preview.js") }}"></script>
         <script type="text/javascript">
+        
+            var emptyRegionMessage = "{% trans "Empty Region" %}"; 
+        
             (function($){
               $(document).ready(function(){
                 dsInit({{ layout.layoutId }}, {{ previewOptions|json_encode()|raw }}, true)

=== modified file 'views/applications-page.twig'
--- views/applications-page.twig	2016-12-15 12:33:44 +0000
+++ views/applications-page.twig	2017-01-12 16:50:38 +0000
@@ -32,6 +32,7 @@
                         <thead>
                             <tr>
                                 <th>{% trans "Name" %}</th>
+                                <th>{% trans "Owner" %}</th>
                                 <th></th>
                             </tr>
                         </thead>
@@ -55,6 +56,7 @@
             ajax: "{{ urlFor("application.search") }}",
             "columns": [
                 { "data": "name" },
+                { "data": "owner" },
                 {
                     "orderable": false,
                     "data": dataTableButtonsColumn

=== modified file 'views/dataset-page.twig'
--- views/dataset-page.twig	2016-09-26 15:31:56 +0000
+++ views/dataset-page.twig	2017-01-16 15:58:46 +0000
@@ -192,7 +192,7 @@
                     <span class="btn btn-success fileinput-button">
                         <i class="glyphicon glyphicon-plus glyphicon glyphicon-white"></i>
                         <span>{{ trans.addFiles }}</span>
-                        <input type="file" name="files[]" multiple>
+                        <input type="file" name="files">
                     </span>
                     <button type="submit" class="btn btn-primary start">
                         <i class="glyphicon glyphicon-upload glyphicon glyphicon-white"></i>

=== modified file 'views/daypart-page.twig'
--- views/daypart-page.twig	2016-09-05 09:24:54 +0000
+++ views/daypart-page.twig	2017-01-03 12:37:33 +0000
@@ -125,6 +125,8 @@
 
                 // Append
                 $exceptions.append(exceptionsTemplate(context));
+                
+                XiboInitialise("#" + $exceptions.prop("id"));
             } else {
                 // For each of the existing exceptions, create form components
                 var i = 0;
@@ -141,6 +143,8 @@
                     };
 
                     $exceptions.append(exceptionsTemplate(context));
+                    
+                    XiboInitialise("#" + $exceptions.prop("id"));
                 });
             }
 
@@ -182,11 +186,11 @@
             </div>
             <div class="col-sm-3">
                 <input type="hidden" name="exceptionStartTimes[]" id="exceptionStartTimes_{{ fieldId }}" value="{{ exceptionStart }}" />
-                <input class="form-control timePicker dateControl" name="exceptionStartTimesLink_{{ fieldId }}" type="text" id="exceptionStartTimesLink_{{ fieldId }}" data-link-field="exceptionStartTimes_{{ fieldId }}" data-link-format="hh:ii" readonly/>
+                <input class="form-control timePicker dateControl" name="exceptionStartTimesLink_{{ fieldId }}" type="text" id="exceptionStartTimesLink_{{ fieldId }}" data-link-field="exceptionStartTimes_{{ fieldId }}" data-link-format="hh:ii"/>
             </div>
             <div class="col-sm-3">
                 <input type="hidden" name="exceptionEndTimes[]" id="exceptionEndTimes_{{ fieldId }}" value="{{ exceptionEnd }}" />
-                <input class="form-control timePicker dateControl" name="exceptionEndTimesLink_{{ fieldId }}" type="text" id="exceptionEndTimesLink_{{ fieldId }}" data-link-field="exceptionEndTimes_{{ fieldId }}" data-link-format="hh:ii" readonly/>
+                <input class="form-control timePicker dateControl" name="exceptionEndTimesLink_{{ fieldId }}" type="text" id="exceptionEndTimesLink_{{ fieldId }}" data-link-field="exceptionEndTimes_{{ fieldId }}" data-link-format="hh:ii"/>
             </div>
             <div class="col-sm-1">
                 <button class="btn btn-default btn-sm"><i class="fa {{ buttonGlyph }}"></i></button>

=== modified file 'views/inline.twig'
--- views/inline.twig	2016-12-15 12:33:44 +0000
+++ views/inline.twig	2017-01-25 14:59:56 +0000
@@ -183,6 +183,17 @@
     </div>
 {% endmacro %}
 
+{% macro dateMonth(name, title, value, helpText, groupClass, validation, accessKey) %}
+    <div class="form-group {{ groupClass }}">
+        <label class="control-label" title="{{ helpText }}" for="{{ name }}" accesskey="{{ accessKey }}">{{ title }}</label>
+        <div class="">
+            <input type="hidden" name="{{ name }}" id="{{ name }}" value="{{ value }}" />
+            {% set linkedName %}{{ name }}Link{% endset %}
+            <input class="form-control dateMonthPicker dateControl" name="{{ linkedName }}" type="text" id="{{ linkedName }}" {{ validation }} data-link-field="{{ name }}" data-link-format="yyyy-mm-dd hh:ii:ss" readonly/>
+        </div>
+    </div>
+{% endmacro %}
+
 {% macro time(name, title, value, helpText, groupClass, validation, accessKey) %}
     <div class="form-group {{ groupClass }}">
         <label class="control-label" title="{{ helpText }}" for="{{ name }}" accesskey="{{ accessKey }}">{{ title }}</label>

=== modified file 'views/layout-designer-page.twig'
--- views/layout-designer-page.twig	2017-01-27 14:10:29 +0000
+++ views/layout-designer-page.twig	2017-02-14 08:43:20 +0000
@@ -46,7 +46,7 @@
                                 <i class="fa fa-clock-o" aria-hidden="true"></i> {% trans "" %}
                                 <span id="layout-duration" class="label label-success big-duration"></span></span>
                             <span>| <b>Currently Editing</b></span>
-                            <select id="layoutJumpList" data-live-search="true">
+                            <select id="layoutJumpList" data-live-search="true" data-width="auto">
                                 {% for item in layouts %}
                                     <option value="{{ urlFor("layout.designer", {id: item.layoutId}) }}"{% if item.layoutId == layout.layoutId %} selected{% endif %}>{{ item.layout }}</option>
                                 {% endfor %}

=== modified file 'views/layout-page.twig'
--- views/layout-page.twig	2016-12-15 12:33:44 +0000
+++ views/layout-page.twig	2017-01-04 11:57:03 +0000
@@ -82,6 +82,7 @@
         $(document).ready(function() {
             table = $("#layouts").DataTable({
                 "language": dataTablesLanguage,
+                "lengthMenu": [10, 25, 50, 100, 250, 500],
                 serverSide: true,
                 stateSave: true,
                 filter: false,

=== modified file 'views/statistics-page.twig'
--- views/statistics-page.twig	2016-07-18 15:59:50 +0000
+++ views/statistics-page.twig	2017-01-25 14:59:56 +0000
@@ -27,8 +27,8 @@
                 <div class="XiboFilter">
                     <div class="FilterDiv" id="bandwidthFilter">
                         <form class="form-inline">
-                            {{ inline.date("bandwidthFromDt", "From Date", defaults.fromDate, "", "", "", "") }}
-                            {{ inline.date("bandwidthToDt", "To Date", defaults.toDate, "", "", "", "") }}
+                            {{ inline.dateMonth("bandwidthFromDt", "From Date", defaults.fromDate, "", "", "", "") }}
+                            {{ inline.dateMonth("bandwidthToDt", "To Date", defaults.toDate, "", "", "", "") }}
                             {{ inline.dropdown("displayId", "single", "Display", "", displayFilterOptions, "displayId", "display") }}
                         </form>
                     </div>

=== removed file 'web/modules/forecastio/standard-icons.png'
Binary files web/modules/forecastio/standard-icons.png and web/modules/forecastio/standard-icons.png differ
=== added file 'web/modules/xibo-image-render.js'
--- web/modules/xibo-image-render.js	1970-01-01 00:00:00 +0000
+++ web/modules/xibo-image-render.js	2017-01-12 14:24:17 +0000
@@ -0,0 +1,79 @@
+/**
+ * Xibo - Digital Signage - http://www.xibo.org.uk
+ * Copyright (C) 2009-2014 Daniel Garner
+ *
+ * This file is part of Xibo.
+ *
+ * Xibo is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU Affero General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * any later version.
+ *
+ * Xibo is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU Affero General Public License for more details.
+ *
+ * You should have received a copy of the GNU Affero General Public License
+ * along with Xibo.  If not, see <http://www.gnu.org/licenses/>.
+ */
+jQuery.fn.extend({
+    xiboImageRender: function(options) {
+
+        // Default options
+        var defaults = {
+            reloadTime: 5000,
+            maxTries: -1 //-1: Infinite # times
+        };
+        
+        // Extend options
+        options = $.extend({}, defaults, options);
+        
+        var $self = $(this);
+        
+        // Run all the selected elements individually
+        if ($self.length > 1) {
+          $self.each(function (i, el) {
+            $(el).xiboImageRender(options);
+          });
+          return $self;
+        }
+        
+        // Handle the image error by replacing the original image with a transparent pixel and try to reload the original source again
+        var handleImageError = function(){
+            
+            // Replace image with a single transparent pixel
+            $self.unbind("error").attr("src", "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAQAAAC1HAwCAAAAC0lEQVR4nGNiYAAAAAkAAxkR2eQAAAAASUVORK5CYII=");
+
+            var reloadTimes = $self.data("reload-times");
+            
+            // Loop an infinite number of times ( maxTries == -1 ) or until the loop reach options.maxTries times
+            if (reloadTimes < options.maxTries || options.maxTries == -1) {
+                
+                // Create a timeout using the options reload time
+                setTimeout(function() {
+                        
+                        // Try to change source to the original
+                        $self.attr("src", $self.data("original-src")).bind("error", handleImageError);
+                        
+                        // Increase the control var and set it to the element
+                        reloadTimes++; 
+                        $self.data("reload-times", reloadTimes); 
+                }, options.reloadTime);
+            }
+        };
+        
+        // Original image source
+        $self.data("original-src", $self.attr("src"));      
+        
+        // Initialise reload times var
+        $self.data("reload-times", 0);
+
+        // Bind handle image funtion to a error event
+        if( $self.data("original-src") != undefined ) {
+            $self.bind("error", handleImageError);
+        } 
+
+        return $self;
+    }
+});

=== modified file 'web/modules/xibo-text-render.js'
--- web/modules/xibo-text-render.js	2016-10-12 10:37:35 +0000
+++ web/modules/xibo-text-render.js	2017-01-11 15:28:44 +0000
@@ -251,11 +251,6 @@
                 $(".page .item:last-child").css("padding", 0);
                 $("#content .item:last-child").css("padding", 0);
             }
-
-            // Protect against images that don't load
-            $(this).find("img").error(function () {
-                $(this).unbind("error").attr("src", "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAQAAAC1HAwCAAAAC0lEQVR4nGNiYAAAAAkAAxkR2eQAAAAASUVORK5CYII=");
-            });
         });
 
         return $(this);

=== modified file 'web/theme/default/css/html-preview.css'
--- web/theme/default/css/html-preview.css	2016-06-08 14:41:13 +0000
+++ web/theme/default/css/html-preview.css	2017-01-24 14:48:47 +0000
@@ -90,3 +90,16 @@
     width: 100%;
     height: 100%;
 }
+
+div.empty-message {
+    position: absolute;
+    top: 50%;
+    left: 50%;
+    transform: translateX(-50%) translateY(-50%);
+}
+
+span.empty-icon {
+    color: rgba(255, 255, 80, 0.6);
+    display:block;
+    text-align: center;
+}

=== modified file 'web/theme/default/js/html-preview.js'
--- web/theme/default/js/html-preview.js	2016-12-15 12:33:44 +0000
+++ web/theme/default/js/html-preview.js	2017-01-24 14:48:47 +0000
@@ -394,7 +394,8 @@
         
         self.curMedia = self.mediaObjects[self.currentMedia];
         
-        playLog(8, "debug", "nextMedia -> New: " + self.curMedia.id);
+        if (self.curMedia != undefined)
+            playLog(8, "debug", "nextMedia -> New: " + self.curMedia.id);
         
         /* Do the transition */
         self.transitionNodes(self.oldMedia, self.curMedia);
@@ -430,6 +431,20 @@
                                                 self.mediaObjects.push(new media(self, $(this).attr('id'), this, options, preload));
                                               });
     
+    // If the regions does not have any media change its background to transparent red
+    if ($(self.xml).find("media").length == 0) {
+        $self = $("#" + self.containerName);
+        
+        messageSize = (self.sWidth > self.sHeight ) ? self.sHeight : self.sWidth;
+        
+        $self.css("background-color", 'rgba(255, 0, 0, 0.25)');
+        $self.append('<div class="empty-message" id="empty_' + self.containerName + '"></div>');
+        
+        $message = $("#empty_" + self.containerName);
+        $message.append('<span class="empty-icon fa fa-exclamation-triangle" style="font-size:' + messageSize/4 + 'px"></span>');
+        $message.append('<span class="empty-icon">' + emptyRegionMessage + '</span>');
+    }     
+                                              
     playLog(4, "debug", "Region " + self.id + " has " + self.mediaObjects.length + " media items");
 }
 

=== modified file 'web/theme/default/js/xibo-cms.js'
--- web/theme/default/js/xibo-cms.js	2016-12-21 13:01:04 +0000
+++ web/theme/default/js/xibo-cms.js	2017-01-25 14:59:56 +0000
@@ -303,6 +303,24 @@
         if (preset != undefined && preset != "")
             $(this).datetimepicker('update', preset);
     });
+    
+    $(scope + ' .dateMonthPicker').each(function() {
+
+        $(this).datetimepicker({
+            format: 'MM yyyy',
+            autoclose: true,
+            language: language,
+            calendarType: calendarType,
+            startView: 3,
+            minView: 3
+        });
+
+        // Get the linked field and use it to set the time
+        var preset = $(this).closest("form").find("#" + $(this).data().linkField).val();
+
+        if (preset != undefined && preset != "")
+            $(this).datetimepicker('update', preset);
+    });
 
     $(scope + ' .timePicker').each(function() {
 
@@ -601,6 +619,10 @@
         data: data,
         success: function(response) {
 
+            // Restore the link to the source object if exists
+            if (typeof sourceObj === "object" || sourceObj instanceof Object)
+                sourceObj.attr("href", lastForm);
+                
             // Was the Call successful
             if (response.success) {
 
@@ -615,10 +637,6 @@
 
                 var id = new Date().getTime();
                 
-                // Restore the link to the source object if exists
-                if (typeof sourceObj === "object" || sourceObj instanceof Object)
-                    sourceObj.attr("href", lastForm);
-                
                 // Create the dialog with our parameters
                 var dialog = bootbox.dialog({
                         message: response.html,

